%NULL                                           = 0
%FALSE                                          = 0
%TRUE                                           = 1
%ERROR_ALREADY_EXISTS                           = 183&
%AC_SRC_OVER                                    = &H00
%AC_SRC_ALPHA                                   = &H01
%SW_SHOW                                        = 5&
%SW_RESTORE                                     = 9&
%WM_DESTROY                                     = &H0002???
%WM_NCHITTEST                                   = &H0084???
%WM_KEYDOWN                                     = &H0100???
%WM_TIMER                                       = &H0113???
%HTCAPTION                                      = 2&
%WS_POPUP                                       = &H80000000&
%WS_EX_TOPMOST                                  = &H00000008&
%WS_EX_LAYERED                                  = &H00080000&
%WS_EX_TOOLWINDOW                               = &H00000080&
%CS_VREDRAW                                     = &H0001???
%CS_HREDRAW                                     = &H0002???
%CS_DBLCLKS                                     = &H0008???
%PM_REMOVE                                      = &H0001???
%ULW_ALPHA                                      = &H00000002???
%SM_CXSCREEN                                    = 0&
%SM_CYSCREEN                                    = 1&
%IDC_ARROW                                      = 32512???

TYPE POINTAPI
   x AS LONG   ' LONG x
   y AS LONG   ' LONG y
END TYPE

TYPE SIZEL
   cx AS LONG   ' LONG x
   cy AS LONG   ' LONG y
END TYPE

TYPE RECT
   nLeft   AS LONG   ' LONG left
   nTop    AS LONG   ' LONG top
   nRight  AS LONG   ' LONG right
   nBottom AS LONG   ' LONG bottom
END TYPE

TYPE SECURITY_ATTRIBUTES
   nLength              AS DWORD   ' DWORD nLength
   lpSecurityDescriptor AS DWORD   ' LPVOID lpSecurityDescriptor
   bInheritHandle       AS LONG    ' BOOL bInheritHandle
END TYPE

TYPE tagMSG
   hwnd    AS DWORD      ' HWND hwnd
   message AS DWORD      ' UINT message
   wParam  AS DWORD      ' WPARAM wParam
   lParam  AS LONG       ' LPARAM lParam
   time    AS DWORD      ' DWORD time
   pt      AS POINTAPI   ' POINT pt
END TYPE

TYPE BITMAP
   bmType       AS LONG       ' LONG
   bmWidth      AS LONG       ' LONG
   bmHeight     AS LONG       ' LONG
   bmWidthBytes AS LONG       ' LONG
   bmPlanes     AS WORD       ' WORD
   bmBitsPixel  AS WORD       ' WORD
   bmBits       AS BYTE PTR   ' LPVOID
END TYPE

TYPE BLENDFUNCTION
   BlendOp             AS BYTE
   BlendFlags          AS BYTE
   SourceConstantAlpha AS BYTE
   AlphaFormat         AS BYTE
END TYPE

TYPE WNDCLASSEXA
   cbSize        AS DWORD        ' UINT        cbSize
   ' /* Win 3.x */
   style         AS DWORD        ' UINT        style
   lpfnWndProc   AS DWORD        ' WNDPROC     lpfnWndProc
   cbClsExtra    AS LONG         ' int         cbClsExtra
   cbWndExtra    AS LONG         ' int         cbWndExtra
   hInstance     AS DWORD        ' HINSTANCE   hInstance
   hIcon         AS DWORD        ' HICON       hIcon
   hCursor       AS DWORD        ' HCURSOR     hCursor
   hbrBackground AS DWORD        ' HBRUSH      hbrBackground
   lpszMenuName  AS ASCIIZ PTR   ' LPCSTR      lpszMenuName
   lpszClassName AS ASCIIZ PTR   ' LPCSTR      lpszClassName
   ' /* Win 4.0 */
   hIconSm       AS DWORD        ' HICON       hIconSm
END TYPE

TYPE BITMAPINFOHEADER
    biSize AS DWORD
    biWidth AS LONG
    biHeight AS LONG
    biPlanes AS WORD
    biBitCount AS WORD
    biCompression AS DWORD
    biSizeImage AS DWORD
    biXPelsPerMeter AS LONG
    biYPelsPerMeter AS LONG
    biClrUsed AS DWORD
    biClrImportant AS DWORD
END TYPE

TYPE RGBQUAD
    rgbBlue AS BYTE
    rgbGreen AS BYTE
    rgbRed AS BYTE
    rgbReserved AS BYTE
END TYPE

TYPE BITMAPINFO
    bmiHeader AS BITMAPINFOHEADER
    bmiColors(256) AS RGBQUAD ' Patrice
END TYPE

TYPE GdiplusStartupInput
   GdiplusVersion AS LONG             ' Must be 1
   DebugEventCallback AS LONG         ' Ignored on free builds
   SuppressBackgroundThread AS LONG   ' FALSE unless you're prepared to call
                                      ' the hook/unhook functions properly
   SuppressExternalCodecs AS LONG     ' FALSE unless you want GDI+ only to use
                                      ' its internal image codecs.
END TYPE

DECLARE FUNCTION GdiplusStartup LIB "gdiplus.dll" ALIAS "GdiplusStartup" (token&, inputbuf AS GdiplusStartupInput, OPTIONAL BYVAL outputbuf&) AS LONG
DECLARE FUNCTION GdiplusShutdown LIB "gdiplus.dll" ALIAS "GdiplusShutdown" (BYVAL token&) AS LONG
DECLARE FUNCTION GdipLoadImageFromFile LIB "gdiplus.dll" ALIAS "GdipLoadImageFromFile" (zFilName AS ASCIIZ, nImage&) AS LONG
DECLARE FUNCTION GdipGetImageWidth LIB "gdiplus.dll" ALIAS "GdipGetImageWidth" (BYVAL nImage&, nWidth&) AS LONG
DECLARE FUNCTION GdipGetImageHeight LIB "gdiplus.dll" ALIAS "GdipGetImageHeight" (BYVAL nImage&, Height&) AS LONG
DECLARE FUNCTION GdipDisposeImage LIB "gdiplus.dll" ALIAS "GdipDisposeImage" (BYVAL nImage&) AS LONG
DECLARE FUNCTION GdipCreateFromHDC LIB "gdiplus.dll" ALIAS "GdipCreateFromHDC" (BYVAL hdc&, graphics&) AS LONG
DECLARE FUNCTION GdipDrawImageRectRectI LIB "gdiplus.dll" ALIAS "GdipDrawImageRectRectI" (BYVAL graphics&, BYVAL nImage&, BYVAL dstx&, BYVAL dsty&, BYVAL dstwidth&, BYVAL dstheight&, BYVAL srcx&, BYVAL srcy&, BYVAL srcwidth&, BYVAL srcheight&, _
                                                                                          BYVAL srcUnit&, OPTIONAL BYVAL imageAttributes&, OPTIONAL BYVAL pCALLBACK&, OPTIONAL BYVAL callbackData&) AS LONG
DECLARE FUNCTION GdipDeleteGraphics LIB "gdiplus.dll" ALIAS "GdipDeleteGraphics" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipSetInterpolationMode LIB "gdiplus.dll" ALIAS "GdipSetInterpolationMode" (BYVAL graphics&, BYVAL interpolation&) AS LONG
DECLARE FUNCTION GdipImageRotateFlip LIB "gdiplus.dll" ALIAS "GdipImageRotateFlip" (BYVAL nImage&, BYVAL rfType&) AS LONG

DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" ( _
   BYREF RECT _                        ' __inout LPRECT lpRect
 , BYVAL DWORD _                       ' __in DWORD dwStyle
 , BYVAL LONG _                        ' __in BOOL bMenu
 , BYVAL DWORD _                       ' __in DWORD dwExStyle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" ( _
   BYVAL DWORD _                       ' __in HANDLE hObject
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" ( _
   BYVAL DWORD _                       ' __in_opt HDC hdc
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpMutexAttributes
 , BYVAL LONG _                        ' __in     BOOL bInitialOwner
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" ( _
   BYVAL DWORD _                       ' __in DWORD dwExStyle
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpClassName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpWindowName
 , BYVAL DWORD _                       ' __in DWORD dwStyle
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt HMENU hMenu
 , BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ANY _                         ' __in_opt LPVOID lpParam
 ) AS DWORD                            ' HWND

DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" ( _
   BYVAL DWORD _                       ' __in HGDIOBJ ho
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DestroyWindow LIB "USER32.DLL" ALIAS "DestroyWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" ( _
   BYREF tagMSG _                      ' __in CONST MSG *lpMsg
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpClassName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpWindowName
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpszClass
 , BYREF WNDCLASSEXA _                 ' __out LPWNDCLASSEXA lpwcx
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 ) AS DWORD                            ' HDC

DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" ( _
   ) AS DWORD                          ' DWORD

DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" ( _
   BYREF tagMSG _                      ' __out LPMSG lpMsg
 , BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMin
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMax
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetObject LIB "GDI32.DLL" ALIAS "GetObjectA" ( _
   BYVAL DWORD _                       ' __in HANDLE h
 , BYVAL LONG _                        ' __in int c
 , BYREF ANY _                         ' __out_bcount_opt(c) LPVOID pv
 ) AS LONG                             ' int

DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" ( _
   BYVAL LONG _                        ' __in int nIndex
 ) AS LONG                             ' int

DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF RECT _                        ' __out LPRECT lpRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION KillTimer LIB "USER32.DLL" ALIAS "KillTimer" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT_PTR uIDEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpCursorName
 ) AS DWORD                            ' HCURSOR

DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpIconName
 ) AS DWORD                            ' HICON

DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" ( _
   BYREF tagMSG _                      ' __out LPMSG lpMsg
 , BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMin
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMax
 , BYVAL DWORD _                       ' __in UINT wRemoveMsg
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" ( _
   BYREF WNDCLASSEXA _                 ' __in CONST WNDCLASSEXA *
 ) AS WORD                             ' ATOM

DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in HDC hDC
 ) AS LONG                             ' int

DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HGDIOBJ h
 ) AS DWORD                            ' HGDIOBJ

DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" ( _
   BYREF RECT _                        ' __out LPRECT lprc
 , BYVAL LONG _                        ' __in int xLeft
 , BYVAL LONG _                        ' __in int yTop
 , BYVAL LONG _                        ' __in int xRight
 , BYVAL LONG _                        ' __in int yBottom
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetTimer LIB "USER32.DLL" ALIAS "SetTimer" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT_PTR nIDEvent
 , BYVAL DWORD _                       ' __in UINT uElapse
 , BYVAL DWORD _                       ' __in_opt TIMERPROC lpTimerFunc
 ) AS DWORD                            ' UINT_PTR

DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nCmdShow
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" ( _
   BYREF tagMSG _                      ' __in CONST MSG *lpMsg
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UpdateLayeredWindow LIB "USER32.DLL" ALIAS "UpdateLayeredWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HDC hdcDst
 , BYREF POINTAPI _                    ' __in_opt POINT *pptDst
 , BYREF SIZEL _                       ' __in_opt SIZE *psize
 , BYVAL DWORD _                       ' __in_opt HDC hdcSrc
 , BYREF POINTAPI _                    ' __in_opt POINT *pptSrc
 , BYVAL DWORD _                       ' __in COLORREF crKey
 , BYREF BLENDFUNCTION _               ' __in_opt BLENDFUNCTION *pblend
 , BYVAL DWORD _                       ' __in_opt BLENDFUNCTION *pblend
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS DWORD

DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" ( _
   BYVAL LONG _                        ' __in int nExitCode
 )                                     ' VOID
